class Arsenicum::MigrationGenerator
  include Rails::Generators::Migration

  def self.orm
    Rails::Generators.options[:rails][:orm]
  end
  def self.source_root
    File.join(File.dirname(__FILE__), 'templates', (orm.to_s unless orm.class.eql?(String)) )
  end

  def self.orm_has_migration?
    [:active_record].include? orm
  end

  def self.next_migration_number(dirname)
    if ActiveRecord::Base.timestamped_migrations
      migration_number = Time.now.utc.strftime("%Y%m%d%H%M%S").to_i
      migration_number += 1
      migration_number.to_s
    else
      "%.3d" % (current_migration_number(dirname) + 1)
    end
  end

  desc "This generator provides the tables which the Arsenicum uses."
  def create_migration_file
    if self.class.orm_has_migration?
      migration_template 'migration.rb', 'db/migrate/create_arsenicum_queues'
    end
  end

end
